<?php

function movdb_main_page ()
{
	?>
	<div class="wrap">
		<h2><?php _e('Movie Database', 'movdb'); ?></h2>
		
		<div id="dashboard-widgets-wrap">
			<div class="metabox-holder columns-2" id="dashboard-widgets">
				<div class="postbox-container" id="postbox-container-1">
					<div class="meta-box-sortables ui-sortable" id="normal-sortables">
						
						<?php movdb_main_page_add_screening(); ?>
						
						<?php movdb_main_page_last_screenings(); ?>
						
						<?php movdb_main_page_recommendations(); ?>
						
					</div>
				</div>
				<div class="postbox-container" id="postbox-container-2">
					<div class="meta-box-sortables ui-sortable" id="side-sortables">
						
						<?php movdb_main_page_statistic(); ?>
						
						<?php movdb_main_page_seen_unrated(); ?>
						
					</div>
				</div>
			</div>
			
			<div class="clear"></div>
			
		</div>
		
	</div>
	<?php
}

function movdb_main_page_add_screening ()
{
	?>
	<div class="postbox" id="movdb_quick_screening_widget">
		<h3 class="hndle"><span><?php _e('Add Screening', 'movdb'); ?></span></h3>
		<div class="inside movdb-inside">
		<?php
		
		movdb_screenings_page_create_edit_form();
		
		?>
		</div>
	</div>
	<?php
}

function movdb_main_page_last_screenings ()
{
	$view = new MovDB_LastScreenings_View();
	$view->prepare_items();
	
	?>
	<div class="postbox" id="movdb_last_screenings_widget">
		<h3 class="hndle"><span><?php _e('Latest Screenings', 'movdb'); ?></span></h3>
		<div class="inside movdb-inside">
		<?php
		
		$view->display();
		
		?>
		</div>
	</div>
	<?php
}

function movdb_main_page_statistic ()
{
	$view = new MovDB_Statistics();
	$view->prepare_items();
	
	?>
	<div class="postbox" id="movdb_statistics_widget">
		<h3 class="hndle"><span><?php _e('Statistics', 'movdb'); ?></span></h3>
		<div class="inside movdb-inside">
		<?php
		
		$view->display();
		
		?>
		</div>
	</div>
	<?php
}

function movdb_main_page_seen_unrated ()
{
	$view = new MovDB_SeenUnrated_View();
	$view->prepare_items();
	
	?>
	<div class="postbox" id="movdb_seen_unrated_widget">
		<h3 class="hndle"><span><?php _e('Seen but not yet rated', 'movdb'); ?></span></h3>
		<div class="inside movdb-inside">
		<?php
		
		$view->display();
		
		?>
		</div>
	</div>
	<?php
}

function movdb_main_page_recommendations ()
{
	$view = new MovDB_Recommendations_View();
	$view->prepare_items();
	
	?>
	<div class="postbox" id="movdb_recommendations_widget">
		<h3 class="hndle"><span><?php _e('Proposals', 'movdb'); ?></span></h3>
		<div class="inside movdb-inside">
		<?php
		
		$view->display();
		
		?>
		</div>
	</div>
	<?php
}

?>